package com.zhuangzi.ncycc.admin.sort;

import com.zhuangzi.ncycc.tools.ConnDB;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;

@WebServlet(name = "SortUpdateServlet",value = "/sortUpdate")
public class SortUpdateServlet extends HttpServlet {
    protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
            response.setContentType("text/html;charset=utf-8");
            PrintWriter out = response.getWriter();
            request.setCharacterEncoding("utf-8");
            int parentid = Integer.parseInt(request.getParameter("parentid"));
            String sortname = request.getParameter("sortname");
            if(sortname.equals("")){
                out.println("<script>alert('类别名称不能为空');history.back();</script>");
                return;
            }
            int orders = Integer.parseInt(request.getParameter("orders"));
            int id     = Integer.parseInt(request.getParameter("id"));
            int oldpid = Integer.parseInt(request.getParameter("oldpid")); //原父id
            String oldsortpath = request.getParameter("oldsortpath");
            ConnDB db = new ConnDB();
            try {
                String sql = "select * from sorts where parentid = ? and sortname = ? and id <> ?";
                ResultSet rs = db.fetch(sql,parentid,sortname,id);
                if(rs.next()){
                    out.println("\"<script>alert('类别已经存在,请更换类别名称');history.back();</script>");
                    return;
                }
            } catch (SQLException e) {
                e.printStackTrace();
            }

            if(oldpid == parentid){
                //父id不变, 则parentid, level都不需要修改
                String sql = "update sorts set sortname = ? , orders = ? where id = ?";
                db.exec(sql,sortname,orders,id);
            }
            else if(parentid == 0){
                //移动到一级类别
                String newSortPath = "0," + id + ",";
                int    newLevel    = 1;
                String sql1 = "update sorts set sortname = ? , orders = ? , sortpath = ?, parentid = ?,level = ? where id = ?";
                int count = db.exec(sql1,sortname,orders,newSortPath,parentid,newLevel,id);

                //更新所有的修改类别的子类
                String sql2  = "update sorts set sortpath = replace(sortpath,?,?) where" +
                        " sortpath like concat('%',?,'%') and id <> ?";
                db.exec(sql2,oldsortpath, newSortPath,oldsortpath,id);

                //更新所有子类的层级
                String sql3  = "update sorts set level = length(sortpath)- length(replace(sortpath,',','')) - 1) where" +
                        " sortpath like concat('%',?,'%') and id <> ?";
                db.exec(sql3,oldsortpath, newSortPath,oldsortpath,id);
            }
            else{
                //判断是否移到了子类别, 这样是不允许的, 中间会断层
                try {
                    //得到当前父类的path
                    String sql = "select sortpath,level from sorts where id = ?";
                    ResultSet rs = db.fetch(sql,parentid);
                    if(rs.next()){
                        String  pSortPath = rs.getString("sortpath");//现在的父path
                        int     level     = rs.getInt("level"); //
                        if(pSortPath.indexOf(oldsortpath) >= 0){
                            out.println("<script>alert('类别不能选择为原父类的子类');history.back();</script>");
                            return;
                        }
                        else{
                            //父类更新上一级或者其它的类别下, 那么该类别下所有的子类都需要更新父级sortpath
                            //新的sortpath
                            String newSortPath = pSortPath + id + ",";
                            int    newLevel    = level + 1;
                            String sql1 = "update sorts set sortname = ? , orders = ? , sortpath = ?, parentid = ?,level = ? where id = ?";
                            int count = db.exec(sql1,sortname,orders,newSortPath,parentid,newLevel,id);

                            //更新所有的修改类别的子类
                            String sql2  = "update sorts set sortpath = replace(sortpath,?,?) where" +
                                    " sortpath like concat('%',?,'%') and id <> ?";
                            db.exec(sql2,oldsortpath, newSortPath,oldsortpath,id);

                            //更新所有子类的层级
                            String sql3  = "update sorts set level = length(sortpath)- length(replace(sortpath,',','')) - 1) where" +
                                    " sortpath like concat('%',?,'%') and id <> ?";
                            db.exec(sql3,oldsortpath, newSortPath,oldsortpath,id);
                        }
                    }
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                finally {
                    db.close();
                }
            }
            out.println("<script>alert('修改成功');location.href='/sortList';</script>");


    }

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
            int id = Integer.parseInt(request.getParameter("id"));
            ConnDB db = new ConnDB();
            try {
                String sql = "select * from sorts where id = ?";
                ResultSet rs = db.fetch(sql,id);
                HashMap<String,Object> hm = new HashMap<>();
                if(rs.next()){
                     hm.put("id",rs.getInt("id"));
                     hm.put("sortname",rs.getString("sortname"));
                     hm.put("orders",rs.getInt("orders"));
                     hm.put("sortpath",rs.getString("sortpath"));
                     int parentid = rs.getInt("parentid");
                     hm.put("parentid",parentid);
                     StringBuffer selects = SortAll.selectTrees(db,0,parentid);
                     hm.put("selects",selects);
                }
                request.setAttribute("hm",hm);
                request.getRequestDispatcher("/jsp/admin/sort/update.jsp").forward(request,response);
            } catch (SQLException e) {
                e.printStackTrace();
            }
            finally {
                db.close();
            }
    }
}
